package com.haopu.GameLogic;

import java.awt.event.InputEvent;

import com.badlogic.gdx.scenes.scene2d.Event;
import com.badlogic.gdx.scenes.scene2d.EventListener;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;
import com.haopu.pak.GameConstant;
import com.haopu.util.GameLayer;
import com.haopu.util.GameStage;
import com.kbz.Actors.ActorImage;
import com.kbz.Actors.GameAction;
import com.kbz.Actors.GameInterface;

public class ActorMask2 implements GameConstant {

	public ActorImage[] maskArray;
	public ActorImage mask;

	/**
	 * 放入一张800*480的蒙版
	 * **/
	public ActorMask2(int imgID, int smallLayer, GameLayer bigLayer) {
		mask = new ActorImage(imgID);
		mask.setPosition(0, 0);
		GameStage.addActorByLayIndex(mask, smallLayer, bigLayer);
	}

	// /**
	// * 放入一张4*4的蒙版
	// * **/
	public ActorMask2(int imgID, int x, int y, int smallLayer,
			GameLayer bigLayer) {
		mask = new ActorImage(imgID);
		mask.setPosition(x, y);
		mask.setScaleX(SCREEN_WIDTH / mask.getWidth());
		mask.setScaleY(SCREEN_HEIGHT / mask.getHeight());
		GameStage.addActorByLayIndex(mask, smallLayer, bigLayer);
	}

	/**
	 * 放入一张4*4的蒙版，放入一个矩形区域，其他部分有蒙版盖住
	 * **/
	public ActorMask2(int imgID, int[] pos, int smallLayer, GameLayer bigLayer) {
		maskArray = new ActorImage[4];
		int x = pos[0];
		int y = pos[1];
		int w = pos[2];
		int h = pos[3];
		// init(maskArray[0], imgID, 0, 0, x, SCREEN_HEIGHT, smallLayer,
		// bigLayer);
		// init(maskArray[1], imgID, x + w, 0, SCREEN_WIDTH - (x + w),
		// SCREEN_HEIGHT, smallLayer, bigLayer);
		// init(maskArray[2], imgID, x, 0, w, y, smallLayer, bigLayer);
		// init(maskArray[3], imgID, x, y + h, w, SCREEN_HEIGHT - (y + h),
		// smallLayer, bigLayer);
		if (x == 0 && y == 0 && h == SCREEN_WIDTH && h == SCREEN_HEIGHT) {
			maskArray[0] = new ActorImage(imgID);
			maskArray[0].setPosition(0, 0);
			maskArray[0].setScaleX(SCREEN_WIDTH / maskArray[0].getWidth());
			maskArray[0].setScaleY(SCREEN_HEIGHT / maskArray[0].getWidth());
			GameStage.addActorByLayIndex(maskArray[0], smallLayer, bigLayer);
			return;
		}
		maskArray[0] = new ActorImage(imgID);
		maskArray[0].setPosition(0, 0);
		maskArray[0].setScaleX(x / maskArray[0].getWidth());
		maskArray[0].setScaleY(SCREEN_HEIGHT / maskArray[0].getWidth());
		GameStage.addActorByLayIndex(maskArray[0], smallLayer, bigLayer);

		maskArray[1] = new ActorImage(imgID);
		maskArray[1].setPosition(x + w, 0);
		maskArray[1].setScaleX((SCREEN_WIDTH - (x + w))
				/ maskArray[1].getWidth());
		maskArray[1].setScaleY(SCREEN_HEIGHT / maskArray[1].getWidth());
		GameStage.addActorByLayIndex(maskArray[1], smallLayer, bigLayer);

		maskArray[2] = new ActorImage(imgID);
		maskArray[2].setPosition(x, 0);
		maskArray[2].setScaleX(w / maskArray[2].getWidth());
		maskArray[2].setScaleY(y / maskArray[2].getWidth());
		GameStage.addActorByLayIndex(maskArray[2], smallLayer, bigLayer);

		maskArray[3] = new ActorImage(imgID);
		maskArray[3].setPosition(x, y + h);
		maskArray[3].setScaleX((w) / maskArray[3].getWidth());
		maskArray[3].setScaleY((SCREEN_HEIGHT - (y + h))
				/ maskArray[3].getWidth());
		GameStage.addActorByLayIndex(maskArray[3], smallLayer, bigLayer);
		
		
	}

	// private void init(ActorImage mask, int imgID, int x, int y, int w, int h,
	// int smallLayer, GameLayer bigLayer) {
	// mask = new ActorImage(imgID);
	// mask.setPosition(x, y);
	// mask.setScaleX(w / mask.getWidth());
	// mask.setScaleY(h / mask.getWidth());
	// GameStage.addActorByLayIndex(mask, smallLayer, bigLayer);
	// }

	/**
	 * 仅支持1慈和2此的action 放入一张4*4的蒙版，放入一个矩形区域，其他部分有蒙版盖住，并且可以移动
	 * **/
	int x, y, w, h;
	int x2, y2, w2, h2;

	public void addAction(int[] pos, float time){
		x2 = pos[0];
		y2 = pos[1];
		w2 = pos[2];
		h2 = pos[3];
		/** 1 **/
		GameAction.clean();
		GameAction.moveTo(0, 0, time);
		GameAction.scaleTo(x2 / maskArray[0].getWidth(), SCREEN_HEIGHT
				/ maskArray[0].getWidth(), time);
		GameAction.startAction(maskArray[0], false, 1);
		/** 2 **/
		GameAction.clean();
		GameAction.moveTo(x2 + w2, 0, time);
		GameAction.scaleTo(
				(SCREEN_WIDTH - (x2 + w2)) / maskArray[1].getWidth(),
				SCREEN_HEIGHT / maskArray[1].getWidth(), time);
		GameAction.startAction(maskArray[1], false, 1);
		/** 3 **/
		GameAction.clean();
		GameAction.moveTo(x2, 0, time);
		GameAction.scaleTo(w2 / maskArray[2].getWidth(),
				y2 / maskArray[2].getWidth(), time);
		GameAction.startAction(maskArray[2], false, 1);
		/** 4 **/
		GameAction.clean();
		GameAction.moveTo(x2, y2 + h2, time);
		GameAction.scaleTo((w2) / maskArray[3].getWidth(),
				(SCREEN_HEIGHT - (y2 + h2)) / maskArray[3].getWidth(), time);
		GameAction.startAction(maskArray[3], false, 1);
	}

	// public void runActorMask() {
	// if (type == Type_One) {
	//
	// }
	// }
}
