package com.haopu.GameLogic;

import java.util.Vector;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.InputListener;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;
import com.haopu.GameEffect.GameEffect;
import com.haopu.GameEntry.GameMain;
import com.haopu.GameShot.GameShot;
import com.haopu.GameSprites.GameMonster;
import com.haopu.GameSprites.GameRole;
import com.haopu.MyMessage.MyMessage;
import com.haopu.map.GameMap;
import com.haopu.pak.GameConstant;
import com.haopu.util.GameLayer;
import com.haopu.util.GameScreen;
import com.haopu.util.GameStage;
import com.kbz.Actors.ActorClipImage;
import com.kbz.Actors.ActorImage;
import com.kbz.Actors.ActorNum;
import com.kbz.Actors.ActorSprite;
import com.kbz.tools.GameRandom;
import com.kbz.tools.Tools;

public class GameEngine extends GameScreen implements GameConstant {

    /******************************** 中途菜单 *******************************************/
    public static boolean isMidMenu = false;
    /******************************** 解决按键和全屏触摸冲突的bug ************************/
    public static boolean isTouched = false;// 解决按键和全屏触摸冲突的bug
    public static final int MAX_TIME = 1000;
    public static GameEngine engine;
    public GameMap map = new GameMap();
    public static int time = 0;
    public static int Score = 0;

    public static int ScoreMax = 0;
    public static int daoDanNum = 1;
    public static int quanPinNum = 1;
    public static int skillNum_FuHuo = 0;

    public static int skillMonsterNum = 0;

    public GameEngine() {
	// TODO 自动生成的构造函数存根
	engine = this;
    }

    @Override
    public void init() {
	isMidMenu = false;
	skillMonsterNum = 0;
	gMonsters = new Vector<GameMonster>();
	MyGameCanvas.sound.playMusic(MUSIC_CHANGJING);
	initUI();
	initRole();
	initMidMenu();
	removeMidMenu();
	isMidMenu = false;
    }

    int winIndex = 0;

    @Override
    public void run() {
	// TODO 自动生成的方法存根
	moveEffect();
	if (isStopFuHuo) {
	    return;
	}
	runFuHuo();
	if (isMidMenu) {
	    return;
	}

	if (time <= 0 || role.hp <= 0) {
	    addFuHuo();
	}
	runRole();
	runUI();
	runVector();
	MonsterToRole();
    }

    @Override
    public void dispose() {
	// TODO 自动生成的方法存根

    }

    /******************************************************************************/
    public GameRole role;

    public void initRole() {
	role = new GameRole(TYPE_ROLE, 400, 240, 1000, GameLayer.ui);
    }

    public void runRole() {
	role.move();
    }

    public Vector<GameMonster> gMonsters = new Vector<GameMonster>();

    public int type, x = 0, y = 0;
    public boolean isLeft = false;

    public void addVector() {
	int _type[] = new int[] { TYPE_ENEMY_1, TYPE_ENEMY_2, };
	type = _type[GameRandom.result(_type.length)];
	isLeft = GameRandom.isSuccess(50) ? true : false;
	x = isLeft ? -50 : 850;
	y = isLeft ? -50 : 530;
	// x=/*800-*/100;
	// y=/*480-*/100;
	GameMonster gmMonster = new GameMonster(type, x, y, 1000, GameLayer.sprite);
	gMonsters.add(gmMonster);
    }

    public void runVector() {
	if (MyGameCanvas.gameTime % 45 == 0) {
	    addVector();
	}
	int size = gMonsters.size();
	for (int i = size - 1; i >= 0; i--) {
	    GameMonster gmMonster = gMonsters.elementAt(i);
	    gmMonster.move();
	    TouchForMonster(i);
	    if (gmMonster.curStatus == STATUS_DEAD) {
		GameStage.removeActor(gmMonster);
		gMonsters.remove(i);
		skillMonsterNum++;
	    }
	}
    }

    public void MonsterToRole() {
	for (int i = 0; i < gMonsters.size(); i++) {
	    if (gMonsters.elementAt(i).isCanMove) {
		continue;
	    }
	    if (gMonsters.elementAt(i).isHitRect(role.getX() + 50, role.getY() + 37, 77, 91)) {
		role.injured(gMonsters.elementAt(i).attack);
		gMonsters.elementAt(i).injured(1000);
	    }
	}
    }

    float posX = 0;
    float posY = 0;
    boolean isPress = false;
    boolean isTemp = false;

    public void TouchForMonster(int i) {
	final GameMonster gmMonster = gMonsters.elementAt(i);
	gmMonster.addListener(new InputListener() {
	    @Override
	    public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
		gmMonster.isCanMove = true;
		return true;
	    }
	});
	if (!gmMonster.isCanMove) {
	    return;
	}
	if (gmMonster.isCanMove) {
	    if (Gdx.input.justTouched()) {
		posX = Gdx.input.getX() * SCREEN_WIDTH / GameMain.sceenWidth;
		posY = Gdx.input.getY() * SCREEN_HEIGHT / GameMain.sceenHeight;

		isPress = true;
	    }
	    if (!isPress) {
		return;
	    }
	    if (Gdx.input.isTouched()) {
		posX = Gdx.input.getX() * SCREEN_WIDTH / GameMain.sceenWidth;
		posY = Gdx.input.getY() * SCREEN_HEIGHT / GameMain.sceenHeight;
		gmMonster.setPosition(posX - gmMonster.getWidth() / 2, posY - gmMonster.getHeight() / 2);

	    }
	    if (!Gdx.input.isTouched() && isPress) {
		isPress = false;

		if (gmMonster.type == TYPE_ENEMY_1 && gmMonster.isHitRect(0, 370, 134, 109)) {
		    gmMonster.injured(1000);
		    gmMonster.isCanMove = false;
		}
		if (gmMonster.type == TYPE_ENEMY_2 && gmMonster.isHitRect(661, 0, 139, 110)) {
		    gmMonster.injured(1000);
		    gmMonster.isCanMove = false;
		}
		if (gmMonster.curStatus != STATUS_DEAD) {
		    gmMonster.isCanMove = false;
		    gmMonster.initProp();
		}

	    }
	}
    }

    /************************************ UI ****************************************/

    static int[][] itemPos = new int[][] { //
    { IMG_STOP, 750, 0 },// 展厅
	    { IMG_JINENG2, 699, 166 }, // 护盾
	    { IMG_JINENG0, 699, 280 },// 全屏
    };
    ActorImage gameBG;
    ActorImage gameBG_DB;
    ActorImage timActorImage;
    ActorClipImage timeActorClipImage;

    ActorImage[] item = new ActorImage[itemPos.length];

    ActorImage[] itemX = new ActorImage[itemPos.length - 1];
    ActorNum[] itemNum = new ActorNum[itemPos.length - 1];

    ActorNum scoreNum;

    // ActorNum levelNum;

    public void initUI() {
	gameBG = new ActorImage(IMG_YOUXIJIEMIAN, 0, 0, 100, GameLayer.bottom);
	gameBG_DB = new ActorImage(IMG_DIBAN, 0, 0, 100, GameLayer.ui);
	// 时间
	time = MAX_TIME;
	timeActorClipImage = new ActorClipImage(IMG_JINDU1, 158, 8, 100, GameLayer.ui);
	timeActorClipImage.setOrigin(0, 0);

	// 道具
	for (int i = 0; i < itemPos.length; i++) {
	    item[i] = new ActorImage(itemPos[i][0], itemPos[i][1], itemPos[i][2], 100, GameLayer.ui);
	    item[i].setOrigin(item[i].getWidth() / 2, item[i].getHeight() / 2);
	}
	// X
	itemX[0] = new ActorImage(IMG_X, 743, 240, 100, GameLayer.ui);
	itemX[1] = new ActorImage(IMG_X, 743, 347, 100, GameLayer.ui);
	// 道具数量
	itemNum[0] = new ActorNum(NUMBER_STYLE_0, daoDanNum, 743 + 17, 240 - 3, 100, GameLayer.ui);
	itemNum[1] = new ActorNum(NUMBER_STYLE_0, quanPinNum, 743 + 17, 347 - 3, 100, GameLayer.ui);

	// 分数
	scoreNum = new ActorNum(NUMBER_STYLE_0, Score, 636, 11, 100, GameLayer.ui);
	// scoreNum.setScale(0.7f);

	// 按钮响应
	initItemTouch();
    }

    public void initItemTouch() {
	for (int i = 0; i < itemPos.length; i++) {
	    final int chooseID = i;
	    item[i].addListener(new ClickListener() {
		@Override
		public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
		    item[chooseID].setScale(1.1f);
		    isTouched = true;
		    return true;
		}

		@Override
		public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
		    item[chooseID].setScale(1.0f);
		    MyGameCanvas.sound.playSound(SOUND_FINDFILAD);
		    isTouched = false;
		    switch (chooseID) {
		    case 0:
			initMidMenu();
			break;
		    case 1:
			if (daoDanNum > 0) {
			    daoDanNum--;
			    role.setWuDi();
			    MyRecord.writeDB(0);
			} else {
			    GameMain.myMessage.makeToast("护盾道具不足,请到商城购买");
			}
			break;
		    case 2:
			if (quanPinNum > 0) {
			    quanPinNum--;
			    for (int i = gMonsters.size() - 1; i >= 0; i--) {
				GameMonster gmMonster = gMonsters.elementAt(i);
				if (gmMonster.getX() >= 0 && gmMonster.getX() <= SCREEN_WIDTH && gmMonster.getY() >= 0 && gmMonster.getY() <= SCREEN_HEIGHT) {
				    gmMonster.injured(1000);
				}
			    }
			} else {
			    GameMain.myMessage.makeToast("导弹道具不足,请到商城购买");
			    MyRecord.writeDB(0);
			}
			break;
		    }
		}
	    });
	}
    }

    public void runUI() {
	time--;
	timeActorClipImage.setClip(0, 0, time * 195 / MAX_TIME, 28);
	itemNum[0].setNum(daoDanNum);
	itemNum[1].setNum(quanPinNum);
	scoreNum.setNum(Score);
    }

    /**************************************** 结算界面 *************************************************/
    ActorImage mask3;

    ActorImage caleDB;

    ActorNum lastScore;

    ActorNum ScoreNum;

    ActorImage[] CaleButton = new ActorImage[2];

    int calePos[][] = {

    { IMG_HZCD, 161, 255 },// 主页

	    { IMG_JXYX, 437, 255 },// 开始游戏

    };

    public void addCale() {
	isMidMenu = true;

	if (ScoreMax == 0) {
	    ScoreMax = Score;
	} else if (Score >= ScoreMax) {
	    ScoreMax = Score;
	}
	MyGameCanvas.sound.playSound(SOUND_DEFENJIEMIAN);

	mask3 = new ActorImage(IMG_MASK, 0, 0, 1000, GameLayer.ui);

	caleDB = new ActorImage(IMG_JIESUANDI, 59, 29, 1000, GameLayer.ui);

	lastScore = new ActorNum(NUMBER_STYLE_0, ScoreMax, NUMBER_CENTER, 266, 198, 1000, GameLayer.ui);

	ScoreNum = new ActorNum(NUMBER_STYLE_0, Score, NUMBER_CENTER, 541, 197, 1000, GameLayer.ui);

	for (int i = 0; i < CaleButton.length; i++) {
	    CaleButton[i] = new ActorImage(calePos[i][0], calePos[i][1], calePos[i][2], 5000, GameLayer.ui);
	    CaleButton[i].setOrigin(CaleButton[i].getWidth() / 2, CaleButton[i].getHeight() / 2);
	    final int chooseID = i;
	    CaleButton[i].addListener(new ClickListener() {
		@Override
		public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
		    CaleButton[chooseID].setScale(1.1f);
		    return true;
		}

		@Override
		public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
		    CaleButton[chooseID].setScale(1.0f);
		    MyGameCanvas.sound.playSound(SOUND_FINDFILAD);
		    switch (chooseID) {
		    case 0:
			removeAllCale();
			GameData.NowFlag = GameData.GameMenu;
			GameStage.clearAllLayers();
			MyGameCanvas.myGameCanvas.setST(ST_OPEN);
			Score = 0;
			break;
		    case 1:
			removeAllCale();
			GameStage.clearAllLayers();
			MyGameCanvas.myGameCanvas.setST(ST_PLAY);
			Score = 0;
			break;
		    }
		}
	    });

	}
    }

    public void removeAllCale() {
	isMidMenu = false;
	GameStage.removeActor(mask3);
	GameStage.removeActor(caleDB);
	caleDB = null;
	GameStage.removeActor(lastScore);
	GameStage.removeActor(ScoreNum);
	for (int i = 0; i < CaleButton.length; i++) {
	    GameStage.removeActor(CaleButton[i]);

	}
    }

    /**************************************** 中途菜单 *************************************************/
    static ActorImage mask;
    static ActorImage[] midButton = new ActorImage[3];
    static int[][] midPos = {

    { IMG_BANGZHU_BG, 197, 89 }, { IMG_JXYX, 296, 146 }, { IMG_HZCD, 296, 260 }, };

    public static void initMidMenu() {
	isMidMenu = true;
	GameData.NowFlag = GameData.GamePause;
	mask = new ActorImage(IMG_MASK, 0, 0, 1000, GameLayer.ui);

	for (int i = 0; i < midPos.length; i++) {
	    midButton[i] = new ActorImage(midPos[i][0], midPos[i][1], midPos[i][2], 5000, GameLayer.ui);
	    midButton[i].setOrigin(midButton[i].getWidth() / 2, midButton[i].getHeight() / 2);

	    if (i == 0) {
		// midButton[i].setScale(0.68f);
		continue;
	    }
	    final int chooseID = i;
	    midButton[i].addListener(new ClickListener() {
		@Override
		public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
		    midButton[chooseID].setScale(1.1f);
		    return true;
		}

		@Override
		public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
		    midButton[chooseID].setScale(1.0f);
		    MyGameCanvas.sound.playSound(SOUND_FINDFILAD);
		    switch (chooseID) {
		    case 0:
			break;
		    case 1:
			removeMidMenu();
			isMidMenu = false;
			break;
		    case 2:
			removeMidMenu();
			GameStage.clearAllLayers();
			MyGameCanvas.myGameCanvas.setST(ST_OPEN);
			isMidMenu = false;
			Score = 0;
			break;
		    }
		}
	    });
	}
    }

    public void setMidMenu(boolean isVisiable) {
	for (int i = 0; i < midPos.length; i++) {
	    midButton[i].setVisible(isVisiable);
	}
	mask.setVisible(isVisiable);
    }

    public static void removeMidMenu() {
	GameData.NowFlag = GameData.GamePlay;
	for (int i = 0; i < midPos.length; i++) {
	    GameStage.removeActor(midButton[i]);
	}
	GameStage.removeActor(mask);
    }

    /**************************************** 复活 *****************************************************/
    boolean isFuHuo = false;
    ActorImage mask2;
    ActorImage fuHuoDB;
    ActorSprite daoShu;
    ActorNum fuHuoNum;
    ActorImage queDing;
    int daoShuIndex = 0;
    public boolean isStopFuHuo = false;
    public static ActorImage guanbi;

    public void addFuHuo() {
	isMidMenu = true;
	daoShuIndex = 0;

	MyGameCanvas.gameTime = 0;

	MyGameCanvas.sound.playSound(SOUND_FUHUOJIEMIAN);

	mask2 = new ActorImage(IMG_MASK, 0, 0, 1000, GameLayer.ui);

	fuHuoDB = new ActorImage(IMG_FUHUO, 177, 110, 1000, GameLayer.ui);

	daoShu = new ActorSprite(366, 148, 1000, GameLayer.ui, IMG_5, IMG_4, IMG_3, IMG_2, IMG_1);
	daoShu.setTexture(0);
	guanbi = new ActorImage(IMG_GUANBISHANGCHENG, 540, 200, 1000, GameLayer.ui);
	guanbi.addListener(new ClickListener() {
	    @Override
	    public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
		return true;
	    }

	    @Override
	    public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
		guanbi.remove();
		removeFuHuo();
		addCale();
	    }
	});
	fuHuoNum = new ActorNum(NUMBER_STYLE_0, skillNum_FuHuo, NUMBER_CENTER, 400, 323, 1000, GameLayer.ui);

	queDing = new ActorImage(IMG_FH, 351 - 10, 266 - 15, 1000, GameLayer.ui);
	queDing.addListener(new ClickListener() {
	    @Override
	    public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
		return true;
	    }

	    @Override
	    public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
		if (skillNum_FuHuo >= 1) {
		    skillNum_FuHuo--;
		    removeFuHuo();
		    MyRecord.writeDB(0);
		    time = MAX_TIME;
		    role.hp = role.hp_max;
		} else {
		    initMidMenu();
		    setMidMenu(false);
		    isStopFuHuo = true;
		    GameMain.myMessage.sendSMS(MyMessage.Billing_复活);
		}
		MyGameCanvas.sound.playSound(SOUND_FINDFILAD);
	    }
	});
    }

    public void removeFuHuo() {
	isMidMenu = false;
	GameStage.removeActor(mask2);
	GameStage.removeActor(fuHuoDB);
	fuHuoDB = null;
	GameStage.removeActor(daoShu);
	GameStage.removeActor(fuHuoNum);
	GameStage.removeActor(queDing);
    }

    public void runFuHuo() {
	if (fuHuoDB == null) {
	    return;
	}
	fuHuoNum.setNum(skillNum_FuHuo);
	if (MyGameCanvas.myGameCanvas.gameTime % 30 == 0) {
	    daoShuIndex++;
	    if (daoShuIndex > 4) {
		removeFuHuo();
		addCale();
		return;
	    }
	    daoShu.setTexture(daoShuIndex);
	}
    }

    /*********************************************** 特效 ************************************************/

    public Vector<GameEffect> gameEffects = new Vector<GameEffect>();

    public void addToEffect(float x, float y, int type, int exp, int layer, GameLayer lay) {
	GameEffect effect = new GameEffect(x, y, type, exp, layer, lay);
	gameEffects.addElement(effect);
    }

    public void moveEffect() {
	int size = gameEffects.size();
	for (int i = size - 1; i >= 0; i--) {
	    GameEffect effect = (GameEffect) gameEffects.elementAt(i);
	    effect.move();
	    if (effect.curStatus == STATUS_NULL) {
		gameEffects.removeElementAt(i);
		GameStage.removeActor(effect);
	    }
	}
    }

    public static void PauseGame() {
	switch (GameData.NowFlag) {
	case GameData.GamePlay:
	    initMidMenu();
	    GameData.NowFlag = GameData.GamePause;
	    break;
	case GameData.GamePause:
	    removeMidMenu();
	    isMidMenu = false;
	    GameData.NowFlag = GameData.GamePlay;
	    break;
	}
    }
}
