package com.haopu.GameLogic;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.InputListener;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;
import com.haopu.GameEntry.GameMain;
import com.haopu.MyMessage.MyMessage;
import com.haopu.pak.GameConstant;
import com.haopu.util.GameLayer;
import com.haopu.util.GameScreen;
import com.haopu.util.GameStage;
import com.kbz.Actors.ActorImage;
import com.kbz.Actors.ActorSprite;

public class GameOpen extends GameScreen implements GameConstant {

	ActorImage openBGImage;
	ActorImage openStartImage[];
	int[][] openPos = { { IMG_KSYX, 605, 268 + 16 },// 开始游戏
			{ IMG_BZ, 0, 0 },// 帮助
			{ IMG_GUANYU, 0, 74 },// 关于
			{ IMG_XINSHOU, 37, 345 },// 新手礼包
			{ IMG_GUANBI, 719, 0 },// 退出
			{ IMG_YXSC, 605, 377 },// 商城
	};
	public static boolean isJiHuo = false;

	@Override
	public void init() {
		InputListener.setOnePress(true);

		MyGameCanvas.sound.playMusic(MUSIC_CHANGJING);

		openBGImage = new ActorImage(IMG_OPEN, 0, 0, 0, GameLayer.bottom);

		addOpen();

		addSetMusic();
	}

	public void addOpen() {
		openStartImage = new ActorImage[openPos.length];
		for (int i = 0; i < openPos.length; i++) {

			openStartImage[i] = new ActorImage(openPos[i][0], openPos[i][1],
					openPos[i][2], 0, GameLayer.bottom);
			openStartImage[i].setOrigin(openStartImage[i].getWidth() / 2,
					openStartImage[i].getHeight() / 2);
			if (i == 3 && isJiHuo) {
				openStartImage[i].setVisible(false);
			}
		}
		buttonForOpen();
	}

	public void buttonForOpen() {
		for (int i = 0; i < openPos.length; i++) {
			final int chooseID = i;
			openStartImage[i].addListener(new ClickListener() {
				@Override
				public boolean touchDown(InputEvent event, float x, float y,
						int pointer, int button) {
					openStartImage[chooseID].setScale(1.1f);
					return true;
				}

				@Override
				public void touchUp(InputEvent event, float x, float y,
						int pointer, int button) {
					openStartImage[chooseID].setScale(1.0f);
					MyGameCanvas.sound.playSound(SOUND_FINDFILAD);
					switch (chooseID) {
					case 0:// 开始游戏
						GameStage.clearAllLayers();
						GameEngine.Score = 0;
						MyGameCanvas.myGameCanvas.setST(ST_PLAY);
						break;
					case 1:// 帮助
						addHelp();
						break;
					case 2:// 关于
						addAbout();
						break;
					case 3:// 跟多
						// GameMain.myMessage.toMore();
//						GameMain.myMessage.sendSMS(MyMessage.Billing_新手大礼包);
						addXinShou();
						break;
					case 4:// 退出
						GameMain.myMessage.exit();
						break;
					case 5:// 商城
						GameShop.addShop();
						break;
					}
				}
			});
		}
	}

	public static ActorImage db;
	public static ActorImage dbButton;
	public static ActorImage exit;
	
	public static void addXinShou(){
		
		mask =new ActorImage(IMG_MASK, 0, 0, 1000, GameLayer.ui);
		
		db = new ActorImage(IMG_XINSHOULIBAO, 400-310/2, 240-130, 1000, GameLayer.ui);
		
		dbButton = new ActorImage(IMG_GOUMAID, 400-56, 240+80, 1000, GameLayer.ui);
		
		exit  = new ActorImage(IMG_X, 400+270/2, 240-120, 1000, GameLayer.ui);
		exit.setScale(2f);
		dbButton.addListener(new ClickListener() {
			@Override
			public boolean touchDown(InputEvent event, float x, float y,
					int pointer, int button) {
				return true;
			}

			@Override
			public void touchUp(InputEvent event, float x, float y,
					int pointer, int button) {
				GameMain.myMessage.sendSMS(MyMessage.Billing_新手大礼包);
			}
		});
		exit.addListener(new ClickListener() {
			@Override
			public boolean touchDown(InputEvent event, float x, float y,
					int pointer, int button) {
				return true;
			}

			@Override
			public void touchUp(InputEvent event, float x, float y,
					int pointer, int button) {
				removeXinShou();
			}
		});
	}
	
	public static void removeXinShou(){
		GameStage.removeActor(mask);
		GameStage.removeActor(db);
		GameStage.removeActor(dbButton);
		GameStage.removeActor(exit);
	}
	
	
	@Override
	public void run() {
		// TODO 自动生成的方法存根
		if (isJiHuo) {
			openStartImage[3].setVisible(false);
		}
	}

	@Override
	public void dispose() {
		// TODO 自动生成的方法存根

	}

	/************************************ 游戏帮助 *****************************************/
	public static ActorImage maxk;
	public static ActorImage helpBG;
	public static ActorImage helpZi;
	public static ActorImage back;

	public static void addHelp() {

		maxk = new ActorImage(IMG_MASK, 0, 0, 1000, GameLayer.ui);

		helpBG = new ActorImage(IMG_BANGZHU_BG, 197, 89, 1000, GameLayer.ui);
		helpBG.setScale(1.1f);
		helpZi = new ActorImage(IMG_BANGZHU_ZI, 197, 89, 1000, GameLayer.ui);

		back = new ActorImage(IMG_GUANBI, 553, 80, 1000, GameLayer.ui);

		back.addListener(new ClickListener() {
			@Override
			public boolean touchDown(InputEvent event, float x, float y,
					int pointer, int button) {
				return true;
			}

			@Override
			public void touchUp(InputEvent event, float x, float y,
					int pointer, int button) {
				// MyGameCanvas.sound.playSound(SOUND_ANNIU);

				GameStage.removeActor(back);
				GameStage.removeActor(maxk);
				GameStage.removeActor(helpBG);
				GameStage.removeActor(helpZi);
			}
		});
	}

	/***************************************************************************************/
	public static ActorImage mask;
	public static ActorImage aboutBG;
	public static ActorImage aboutZi;
	public static ActorImage backAbout;

	public static void addAbout() {
		mask = new ActorImage(IMG_MASK, 0, 0, 1000, GameLayer.ui);

		aboutBG = new ActorImage(IMG_BANGZHU_BG, 197, 89, 1000, GameLayer.ui);
		aboutBG.setScale(1.1f);
		aboutZi = new ActorImage(IMG_GUANYU_ZI, 197, 89, 1000, GameLayer.ui);

		backAbout = new ActorImage(IMG_GUANBI, 553, 80, 1000, GameLayer.ui);
		backAbout.addListener(new ClickListener() {
			@Override
			public boolean touchDown(InputEvent event, float x, float y,
					int pointer, int button) {
				return true;
			}

			@Override
			public void touchUp(InputEvent event, float x, float y,
					int pointer, int button) {
				// MyGameCanvas.sound.playSound(SOUND_ANNIU);
				GameStage.removeActor(mask);
				GameStage.removeActor(aboutBG);
				GameStage.removeActor(aboutZi);
				GameStage.removeActor(backAbout);
			}
		});
	}

	/************************************** 设置 ********************************************/

	public static ActorSprite musicTB;

	// public static ActorSprite soundTB;

	public static void addSetMusic() {
		// 声音
		musicTB = new ActorSprite(0, 149, 1000, GameLayer.ui, IMG_SY, IMG_SY);
		if (MyGameCanvas.sound.isMusicOpen) {
			musicTB.setTexture(0);
			MyGameCanvas.sound.setMusicOpen(true);
			MyGameCanvas.sound.setSoundOpen(true);
			musicTB.setColor(Color.WHITE);
		} else {
			musicTB.setTexture(1);
			MyGameCanvas.sound.setMusicOpen(false);
			MyGameCanvas.sound.setSoundOpen(false);
			musicTB.setColor(Color.GRAY);
		}
		musicTB.addListener(new ClickListener() {
			@Override
			public boolean touchDown(InputEvent event, float x, float y,
					int pointer, int button) {
				return true;
			}

			@Override
			public void touchUp(InputEvent event, float x, float y,
					int pointer, int button) {
				MyGameCanvas.sound.isMusicOpen = !MyGameCanvas.sound.isMusicOpen;
				if (MyGameCanvas.sound.isMusicOpen) {
					musicTB.setTexture(0);
					MyGameCanvas.sound.setMusicOpen(true);
					MyGameCanvas.sound.setSoundOpen(true);
					musicTB.setColor(Color.WHITE);
				} else {
					musicTB.setTexture(1);
					MyGameCanvas.sound.setMusicOpen(false);
					MyGameCanvas.sound.setSoundOpen(false);
					musicTB.setColor(Color.GRAY);
				}
				MyGameCanvas.sound.playSound(SOUND_FINDFILAD);
			}
		});
		// // 音效
		// soundTB = new ActorSprite(14, 332, 1000, GameLayer.ui, IMG_YX,
		// IMG_YX);
		// if (MyGameCanvas.sound.isSoundOpen) {
		// soundTB.setTexture(0);
		// MyGameCanvas.sound.setSoundOpen(true);
		// soundTB.setColor(Color.WHITE);
		// } else {
		// soundTB.setTexture(1);
		// MyGameCanvas.sound.setSoundOpen(false);
		// soundTB.setColor(Color.GRAY);
		// }
		// soundTB.addListener(new ClickListener() {
		// @Override
		// public boolean touchDown(InputEvent event, float x, float y,
		// int pointer, int button) {
		// return true;
		// }
		//
		// @Override
		// public void touchUp(InputEvent event, float x, float y,
		// int pointer, int button) {
		// MyGameCanvas.sound.isSoundOpen = !MyGameCanvas.sound.isSoundOpen;
		// if (MyGameCanvas.sound.isSoundOpen) {
		// soundTB.setTexture(0);
		// MyGameCanvas.sound.setSoundOpen(true);
		// soundTB.setColor(Color.WHITE);
		// } else {
		// soundTB.setTexture(1);
		// MyGameCanvas.sound.setSoundOpen(false);
		// soundTB.setColor(Color.GRAY);
		// }
		// MyGameCanvas.sound.playSound(SOUND_FINDFILAD);
		// }
		//
		// });
	}

}
