package com.haopu.GameLogic;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Preferences;
import com.badlogic.gdx.scenes.scene2d.Action;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.utils.SnapshotArray;
import com.haopu.pak.GameConstant;
import com.haopu.util.GameLayer;
import com.haopu.util.GameScreen;
import com.haopu.util.GameStage;
import com.kbz.Actors.ActorNum;
import com.kbz.Actors.GameAction;
import com.kbz.Sound.GameSound;
import com.kbz.tools.Tools;

public class MyGameCanvas extends GameScreen implements GameConstant {

	public static int gameStatus = 999; // don`t change!!!!!!!!!!!!!!!!!!!!!
	public static int gameLastStatus = -1;
	protected Group curStateGroup;
	private GameOpen openST;
	private GameEngine playST;
	GameSP gameSP;
	/**
	 * 存档功能
	 */
	public static Preferences saveData;

	public static MyGameCanvas myGameCanvas;

	public MyGameCanvas() {
		myGameCanvas = this;
	}

	int index;
	public static int gameTime = 0;

	public void setST(int index) {
		if (gameStatus != 999) {
			gameLastStatus = gameStatus;
		}
		gameStatus = index;
		stateChange();
		index = 0;
	}

	public void stateChange() {
		stateDispose();
		stateInit();
	}

	/**
	 * 每个状态的资源加载 数据初始化
	 */
	public void stateInit() {
		// if (fpsActorNum == null) {
		// addFpsNumber();
		//
		// System.err.println("stateInit:" + gameStatus);
		// }
		switch (gameStatus) {
		case ST_STARTLOAD:
			break;
		case ST_SP:
			gameSP.init();
			break;
		case ST_LOGO:
			break;
		case ST_LOAD:
			break;
		case ST_OPEN:
			openST.init();
			break;
		case ST_GAMENEWMAP:
			break;
		case ST_SUPERGAME:
			break;
		case ST_PERSONAL:
			break;
		case ST_MAPCHOOSE:
			break;
		case ST_PLAY:
			playST.init();
			openScreenEff(playST.curStateGroup);
			break;
		case ST_SHOP:
			break;
		case ST_MENU:
			break;
		case ST_MAPCHOOSERANK:
			break;
		default:
			break;
		}
	}


	/**
	 * 每个状态的资源卸载 数据清楚
	 */
	public void stateDispose() {

		switch (gameLastStatus) {
		case ST_STARTLOAD:
			break;
		case ST_SP:

			break;
		case ST_LOGO:

			break;
		case ST_LOAD:

			break;
		case ST_OPEN:
			if (openST == null) {
				System.out.println("openST ==null");
			} else if (openST.curStateGroup == null) {
				System.out.println("curStaGroup == null");
			} else {
				closeScreenEff(openST.curStateGroup);
			}
			break;
		case ST_SHOP:
			break;
		case ST_PLAY:
			playST.dispose();
			break;
		case ST_MAPCHOOSERANK:
			break;
		case ST_MAPCHOOSE:
			break;
		case ST_GAMENEWMAP:
			break;
		case ST_SUPERGAME:
			break;
		case ST_PERSONAL:
			break;
		default:
			break;
		}

	}

	ActorNum fpsActorNum;

	public void addFpsNumber() {

		// fpsActorNum = new ActorNum(NUMBER_STYLE_0, (int)GameStage.getFPS(),
		// 0, 0,
		// 10000, GameLayer.top);

		// fpsActorNum = new ActorNum(NUMBER_STYLE_0, 0, 0, 0, 100,
		// GameLayer.top);
		//
		// fpsActorNum.setPosition(Tools.setOffX, Tools.setOffY);
		// fpsActorNum.setNum(GameStage.getFPS());
		//
		// GameStage.addActorByLayIndex(fpsActorNum, 100, GameLayer.top);

		fpsActorNum = new ActorNum(NUMBER_STYLE_0, 0, 0, 0, 100, GameLayer.top);
		// fpsActorNum.setPosition(Tools.setOffX, Tools.setOffY);
		fpsActorNum.setNum(GameStage.getFPS());

		GameStage.addActorByLayIndex(fpsActorNum, 100, GameLayer.top);
	}

	/**
	 * 每个状态的运行
	 */
	public void paint() {
		gameTime++;
		switch (gameStatus) {
		case ST_STARTLOAD:
			break;
		case ST_SM:
			break;
		case ST_SP:
			gameSP.run();
			break;
		case ST_LOGO:
			break;
		case ST_LOAD:

			break;
		case ST_OPEN:
			openST.run();
			break;
		case ST_SHOP:
			break;
		case ST_PLAY:
			playST.run();
			break;
		case ST_MAPCHOOSERANK:
			break;
		case ST_MAPCHOOSE:
			break;
		case ST_GAMENEWMAP:
			break;
		case ST_SUPERGAME:
			break;
		case ST_PERSONAL:
			break;
		default:
			break;
		}

	}

	// 切换状态效果
	public void closeScreenEff(final Group group) {

		group.setOrigin(SCREEN_WIDTH / 2, SCREEN_HEIGHT / 2);
		// 添加一个关屏效果使用 action来实现
		GameAction.clean();

		GameAction.alpha(0, 0.5f);
		GameAction.rotateBy(360, 0.5f);
		GameAction.scaleTo(0, 0, 0.5f);

		Action isEndAction = Actions.run(new Runnable() {
			@Override
			public void run() {
				// TODO Auto-generated method stub
				group.clear();
			}
		});
		GameAction.addAction(isEndAction);
		GameAction.setAction(new int[] { 0, 1, 2 }, false);
		GameAction.setAction(new int[] { 3 }, false);
		GameAction.startAction(group, true, 1);
	}

	// 切换状态效果
	public void openScreenEff(final Group group) {

		group.setOrigin(SCREEN_WIDTH / 2, SCREEN_HEIGHT / 2);

		GameAction.clean();

		GameAction.alpha(0);
		GameAction.scaleTo(0, 0, 0);

		GameAction.alpha(1, 0.5f);
		GameAction.scaleTo(1f, 1f, 0.5f);
		GameAction.rotateBy(360, 0.5f);

		Action isEndAction = Actions.run(new Runnable() {
			@Override
			public void run() {
				// TODO Auto-generated method stub
				System.out.println("111111111");
				// GameStage.sortAndAddGameStage();
				GameStage.removeActor(GameLayer.bottom, group);
			}
		});
		GameAction.addAction(isEndAction);
		GameAction.setAction(new int[] { 0, 1 }, false);
		GameAction.setAction(new int[] { 2, 3, 4 }, false);
		GameAction.setAction(new int[] { 5 }, true);
		GameAction.startAction(group, true, 1);

	}

	public void addAllActor(Group curStateGroup) {
		SnapshotArray<Actor> children = GameStage.getLayer(GameLayer.bottom)
				.getChildren();
		for (int i = 0; i < children.size; i++) {
			curStateGroup.addActor(children.get(i));
		}
		SnapshotArray<Actor> children1 = GameStage.getLayer(GameLayer.map)
				.getChildren();
		for (int i = 0; i < children1.size; i++) {
			curStateGroup.addActor(children1.get(i));
		}
		SnapshotArray<Actor> children2 = GameStage.getLayer(GameLayer.sprite)
				.getChildren();
		for (int i = 0; i < children2.size; i++) {
			curStateGroup.addActor(children2.get(i));
		}
		SnapshotArray<Actor> children3 = GameStage.getLayer(GameLayer.ui)
				.getChildren();
		for (int i = 0; i < children3.size; i++) {
			curStateGroup.addActor(children3.get(i));
		}
		SnapshotArray<Actor> children4 = GameStage.getLayer(GameLayer.top)
				.getChildren();
		for (int i = 0; i < children4.size; i++) {
			curStateGroup.addActor(children4.get(i));
		}
	}

	public static GameSound sound = new GameSound();
	
	@Override
	public void init() {
		// TODO Auto-generated method stub
		Tools.initTools(isDebugMode);
		sound.init(SOUND_NAME, MUSIC_NAME);
		openST = new GameOpen();
		playST = new GameEngine();
		gameSP = new GameSP();
		MyRecord.readDB(0);
		setST(ST_SP);
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		paint();
	}

	@Override
	public void dispose() {
		// TODO Auto-generated method stub

	}

}
